/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package balonky;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.Box;
import javax.swing.BoxLayout;
/**
 *
 * @author petr
 */
public class BalonekPanel extends Box {
    private final int FPS = 24;
    List<Balonek> balonky;
    Timer clock;

    public BalonekPanel() {
        this(0);
    }

    public BalonekPanel(int pocet) {
        super(BoxLayout.X_AXIS);
        balonky = new ArrayList<Balonek>();
        for(int i = 0; i < pocet; i++) {
            balonky.add(new Balonek(new Dimension(640,480)));
        }
        clock = new Timer();
        clock.schedule(new TimerTask() {
            @Override
            public void run() {
                  BalonekPanel.this.repaint();
            }
        }, 0,1000/FPS);

        addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if(e.getButton() != MouseEvent.BUTTON3) {
                       balonky.add(new Balonek(new Dimension(BalonekPanel.this.getWidth(),
                               BalonekPanel.this.getHeight())));
                }/*
                else {
                    ListIterator<Balonek> it = balonky.listIterator(balonky.size());
                    while(it.hasPrevious()) {
                        Balonek b = it.previous();
                        int x = e.getX();
                        int y = e.getY();
                        Point pozice = b.getPozice();
                        int polomer = b.getPolomer();
                        double r = Math.sqrt(Math.pow(x - pozice.x,2) + Math.pow(y-pozice.y, 2));
                        if(r < polomer)  {
                            it.remove();
                            break;
                        }
                    }
                }
                  */
            }
        });
    }

    @Override
    public Dimension getPreferredSize() {
        return new Dimension(640,480);
    }
    @Override
    public Dimension getMinimumSize() {
        return this.getPreferredSize();
    }
    
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        ListIterator<Balonek> it = balonky.listIterator();
        while(it.hasNext()) {
            it.next().paint(g);
        }
    }
}